<template>
  <div class="login">
    <h1 class="title">
      全国道路运输企业主要负责人和
      <br />安全生产管理人员安全考核管理
    </h1>
    <div class="login-box">
      <div class="login-hd">
        <h2 class="login-title">绑定</h2>
      </div>
      <div class="login-bd">
        <div class="login-form">
          <!-- 账号登录 -->
          <!-- <account-login ref="form" @submit="onSubmit" v-if="!this.isWechat"></account-login> -->
          <!-- 验证码登录 -->
          <code-login ref="form" @submit="onSubmit"></code-login>
          <div class="login-button" @click="handleSubmit">立即绑定</div>
        </div>
      </div>
      <!-- <div class="login-ft">
        <ul>
          <li @click="wechatLogin">
            <img src="../../assets/images/login_wechat.png" alt="微信登录" />微信登录
          </li>
        </ul>
      </div>-->
    </div>
  </div>
</template>
<script>
import Cookies from 'js-cookie'

import * as api from '@/api/account'
import AccountLogin from './accountLogin.vue'
import CodeLogin from './codeLogin.vue'

export default {
  components: { AccountLogin, CodeLogin },
  data() {
    const UA = navigator.userAgent.toLowerCase()
    return {
      ruleForm: {
        type: 2,
        account: '',
        code: '',
        password: '',
        RememberMe: true,
        service: 'https://h5.ezijing.com'
      },
      passwordVisible: false,
      isWechat: /micromessenger/.test(UA),
      unionid: Cookies.get('wechat_login_no_phone_error')
    }
  },
  computed: {
    isWeapp() {
      return this.$store.state.isWeapp
    },
    // 重定向地址
    redirectURI() {
      const { query } = this.$route
      return query.redirect_uri ? decodeURIComponent(query.redirect_uri) : ''
    }
  },
  methods: {
    handleSubmit() {
      this.$refs.form.submit()
    },
    // 提交
    onSubmit(data) {
      this.unionid ? this.bindWechat(data) : this.loginRequest(data)
    },
    // 登录
    loginRequest(data) {
      const params = Object.assign({}, this.ruleForm, data)
      api
        .login(params)
        .then(response => {
          this.loginSuccess(response)
        })
        .catch(error => {
          error.response && this.$toast(error.response.data.message)
        })
    },
    // 绑定微信并登录
    bindWechat(data) {
      const params = Object.assign({}, this.ruleForm, data, {
        unionid: this.unionid,
        code: data.password
      })
      api
        .bindWechat(params)
        .then(response => {
          this.loginSuccess(response)
        })
        .catch(error => {
          error.response && this.$toast(error.response.data.message)
        })
    },
    // 登录成功
    loginSuccess(response, delta = 2) {
      if (response.code === 0) {
        Cookies.remove('wechat_login_error', { domain: '.ezijing.com' })
        Cookies.remove('wechat_login_no_phone_error', {
          domain: '.ezijing.com'
        })
        this.$store.commit('setToken', response.data.TGC)
        if (this.isWeapp) {
          wx.miniProgram.postMessage({ data: { token: response.data.TGC } })
          wx.miniProgram.navigateBack({ delta })
          return
        }
        if (this.redirectURI) {
          window.location.href = this.redirectURI
        } else {
          this.$router.replace('/')
        }
      } else {
        this.$toast(response.msg)
      }
    },
    wechatLogin() {
      const appId = 'wx451c01d40d090d7a'
      // 回调地址
      const redirectURI = `https://passport.ezijing.com/rest/wechat/oauth-callback?needCheck=false&identity=transport&redirectUrl=${window.location.href}`
      // 微信的地址
      const wechatUrl = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=${appId}&redirect_uri=${encodeURIComponent(
        redirectURI
      )}&response_type=code&scope=snsapi_userinfo&state=STATE#wechat_redirect`
      // 打开地址
      window.location.href = wechatUrl
    },
    checkWechatLogin() {
      return !!(
        Cookies.get('wechat_login_error') ||
        Cookies.get('wechat_login_no_phone_error')
      )
    }
  },
  beforeMount() {
    this.$store.dispatch('checkLogin').then(isLogin => {
      if (isLogin) {
        this.loginSuccess({ code: 0, data: { TGC: Cookies.get('TGC') } }, 1)
      } else {
        if (this.isWechat && !this.checkWechatLogin()) {
          this.wechatLogin()
        }
      }
    })
  }
}
</script>
<style lang="scss">
.login {
  position: relative;
  min-height: 100vh;
  display: flex;
  flex-direction: column;
  background: url('../../assets/images/login_bg.png') no-repeat;
  background-size: contain;
}
.login-box {
  position: absolute;
  top: 100px;
  left: 50px;
  right: 50px;
  height: 400px;
  padding: 20px;
  background: rgba(255, 255, 255, 1);
  box-shadow: 0px 10px 20px 0px rgba(0, 0, 0, 0.1);
  border-radius: 20px;
}
.login-hd {
  padding: 10px 0;
}
.login-title {
  display: inline-block;
  font-size: 24px;
  color: #2b7ce9;
  border-bottom: 5px solid #2b7ce9;
}
.login-bd {
  margin-top: 20px;
  flex: 1;
}
.login-button {
  margin-top: 40px;
  height: 40px;
  font-size: 12px;
  color: #fff;
  line-height: 40px;
  background: linear-gradient(
    270deg,
    rgba(43, 124, 233, 1) 0%,
    rgba(103, 168, 255, 1) 100%
  );
  text-align: center;
  border-radius: 3px;
  cursor: pointer;
}
.login-ft {
  padding: 20px 0;
  li {
    display: inline-block;
    height: 30px;
    line-height: 30px;
    font-size: 12px;
    color: #ccc;
    cursor: pointer;
  }
  img {
    width: 30px;
    margin-right: 5px;
  }
}
.login-tips {
  text-align: center;
  font-size: 12px;
  color: #999;
  .forget-password {
    color: #1989fa;
  }
}
.login {
  .title {
    padding: 30px 0;
    font-size: 15px;
    font-weight: 600;
    color: #fff;
    line-height: 30px;
    text-align: center;
  }
  .van-field {
    margin-bottom: 20px;
    padding: 0;
    flex-direction: column;
  }
  .van-field__label {
    font-size: 12px;
    color: #222;
    line-height: 1;
    margin-bottom: 5px;
    padding-left: 10px;
  }
  .van-field__control {
    padding: 8px;
    border: 1px solid #ccc;
    border-radius: 3px;
  }
}
</style>
